VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   2715
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4020
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2715
   ScaleWidth      =   4020
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Pic1 
      Height          =   2055
      Left            =   120
      ScaleHeight     =   1995
      ScaleWidth      =   3675
      TabIndex        =   1
      Top             =   480
      Width           =   3735
   End
   Begin VB.Timer Timer1 
      Left            =   1800
      Top             =   4800
   End
   Begin MSComctlLib.ProgressBar ProgressBar2 
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim hmixer As Long                  ' mixer handle
Dim inputVolCtrl As MIXERCONTROL    ' waveout volume control
Dim outputVolCtrl As MIXERCONTROL   ' microphone volume control
Dim rc As Long                      ' return code
Dim ok As Boolean                   ' boolean return code

Dim mxcd As MIXERCONTROLDETAILS         ' control info
Dim vol As MIXERCONTROLDETAILS_SIGNED   ' control's signed value
Dim volume As Long                      ' volume value
Dim volHmem As Long                     ' handle to volume memory
Dim PicX As Integer
Dim PicY As Integer
Dim NewX As Integer
Dim NewY As Integer
Dim OldX As Integer
Dim OldY As Integer
Dim Started As Boolean

Private Sub Form_Load()
   'Made by:
   'Nepveux Software
   'Email: nepvetm@worldnet.att.net
   
   'Based on:
   'KPD-Team 1999
   'URL: http://www.allapi.net/
   'E-Mail: KPDTeam@Allapi.net
   Me.ScaleMode = vbTwips
   Me.Caption = "Graphical volume meter"
   Timer1.Interval = 50
   Timer1.Enabled = True
   
   ' Open the mixer specified by DEVICEID
   rc = mixerOpen(hmixer, DEVICEID, 0, 0, 0)
   
   If ((MMSYSERR_NOERROR <> rc)) Then
       MsgBox "Couldn't open the mixer."
       Exit Sub
   End If
       
   ' Get the output volume meter
   ok = GetControl(hmixer, MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT, MIXERCONTROL_CONTROLTYPE_PEAKMETER, outputVolCtrl)
   
   If (ok = True) Then
      ProgressBar2.Min = 0
      ProgressBar2.Max = outputVolCtrl.lMaximum
   Else
      ProgressBar2.Enabled = False
      MsgBox "Couldn't get waveout meter"
   End If
   
   ' Initialize mixercontrol structure
   mxcd.cbStruct = Len(mxcd)
   volHmem = GlobalAlloc(&H0, Len(volume))  ' Allocate a buffer for the volume value
   mxcd.paDetails = GlobalLock(volHmem)
   mxcd.cbDetails = Len(volume)
   mxcd.cChannels = 1
   PicX = 0
   PicY = 1950
   NewX = 0
   NewY = 1950
   Started = False
End Sub

Private Sub Timer1_Timer()

   On Error Resume Next

   ' Get the current output level
   If (ProgressBar2.Enabled = True) Then
      mxcd.dwControlID = outputVolCtrl.dwControlID
      mxcd.item = outputVolCtrl.cMultipleItems
      rc = mixerGetControlDetails(hmixer, mxcd, MIXER_GETCONTROLDETAILSF_VALUE)
      CopyStructFromPtr volume, mxcd.paDetails, Len(volume)
      
      If (volume < 0) Then volume = -volume
      ProgressBar2.Value = volume
      
      Dim Val As Long
      Val = Int(ProgressBar2.Value * (100 / ProgressBar2.Max))
      
      PicY = 1950 - (1950 * (Val / 100))
      
      If (PicX + 40) < 3730 Then
      PicX = PicX + 40
      Else
      Pic1.Cls
      PicX = 0
      Started = False
      End If
      
      Pic1.Circle (PicX, PicY), 1, RGB(0, 0, 0)
      
      OldX = NewX
      OldY = NewY
      NewX = PicX
      NewY = PicY
      If Started = True Then
      Pic1.Line (OldX, OldY)-(NewX, NewY), RGB(0, 0, 0)
      Else
      Started = True
      End If
      
   End If
End Sub
Private Sub Form_Unload(Cancel As Integer)
   GlobalFree volHmem
End Sub




